#version 150

#moj_import <fog.glsl>

#moj_import <light.glsl>

uniform sampler2D Sampler0;
uniform sampler2D Sampler2;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
flat in vec3 normal;
in vec3 position;
in vec2 faceCoords;
in vec4 lightlevel;

out vec4 fragColor;

#define RED vec4(1,0,0,1)
#define FAR 20


vec4 rgb(float r, float g, float b){
    return vec4(r / 255., g / 255., b / 255., 1);
}


void main() {
    float epsilon = 0.001;
    vec4 blockTex = texture(Sampler0, texCoord0);
    if ((blockTex.a * 255. - 254.) < epsilon){
        // specular attempt lol
        float specularStrength = 0.5;
        vec3 lightDir = normalize(vec3(0,-1,0));
        lightDir.y = abs(lightDir.y);
        // make specular pixely use floor(position * (sin(GameTime*2000)*8+16))
        vec3 viewDir = normalize(position);
        vec3 reflectDir = reflect(lightDir, normal);

        float spec = pow(max(dot(viewDir, reflectDir), 0.0), 2);
        vec4 specular = specularStrength * spec * texture(Sampler0, texCoord0);
        // compositing specular, fake ambient light
        blockTex *= specular * clamp(1 - (length(position) / FAR),0,1) + vertexColor;
        // blockTex = blockTex / 1.1 + 0.05;
        // blockTex = blockTex * 1.3 - 0.05;
        fragColor = linear_fog(blockTex, vertexDistance, FogStart, FogEnd, FogColor);
    }else{
        vec4 color = (blockTex * vertexColor * ColorModulator);
        fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
        // fragColor = RED;
    }
        
}
